#ifdef __WIN32__
#include <winsock.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#endif
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define MAX_IF 3
#define MAX_REC_IN_FILE 10000;
#define FileName "router"
char ver_fu[] = "Function Utils Ver 0.1\n";

struct rec{
int num;
char dns[100];
long addr,if_addr[MAX_IF];
void *next;
};
struct rec *top,*tmp,*prev,curr;
int num_rec,i;
FILE *f;

char *ltoip(long l)
{
 struct in_addr a;
 a.s_addr=l;
 return(inet_ntoa(a));
}

long iptol(char *ip_str)
{
 return(inet_addr(ip_str));
}

short checksum(short *buffer, short size) {
  int cksum=0;
  while(size >1) {
	cksum+=*buffer++;
	size -=sizeof(short);
  }
  if(size ) {
	cksum += *(int*)buffer;
  }
  cksum = (cksum >> 16) + (cksum & 0xffff);
  cksum += (cksum >>16);
  return (short)(~cksum);
}

int add_rec()
{
if(!top)
	{tmp=(struct rec *)malloc(sizeof(struct rec));top=tmp;prev=tmp;num_rec=1;}
else
	{tmp=(struct rec *)malloc(sizeof(struct rec));prev->next=tmp;prev=tmp;};
	*tmp=curr;
	tmp->num=num_rec++;
	strcpy(tmp->dns,curr.dns);
return(num_rec);
}

int del_db()
{
	tmp=top;
while(tmp)
	{
		prev=tmp;
		tmp=tmp->next;
		free(prev);
	}
top = tmp = prev = NULL;	
return(0);
}

int print_rec()
{
	tmp=top;
if(!tmp)fprintf(stdout,"data base empty\n");
while(tmp)
	{
		fprintf(stdout,"%d %s %s ",tmp->num,tmp->dns,ltoip(tmp->addr));
		for(i=0;i<MAX_IF;++i)fprintf(stdout,"if[%d]: %s ",i,ltoip(tmp->if_addr[i]));
		fprintf(stdout,"\n");
		tmp=tmp->next;
	}
return(0);
}

int save_db()
{
if(!(f=fopen(FileName,"r")))
{
 fprintf(stdout,"File %s not found\nCreated new file %s\n",FileName,FileName);
}
else fclose(f);
if(!(f=fopen(FileName,"w")))
{
 fprintf(stdout,"error open file %s on write\n",FileName);return(-1);
}
fprintf(f,ver_fu);
fprintf(f,"BEGIN\n");
	tmp=top;
while(tmp)
	{
		fprintf(f,"%d %s %s ",tmp->num,tmp->dns,ltoip(tmp->addr));
		for(i=0;i<MAX_IF;++i)fprintf(f,"%s ",ltoip(tmp->if_addr[i]));
		fprintf(f,"\n");
		tmp=tmp->next;
	}
fprintf(f,"END\n");	
fclose(f);
return(0);
}

int load_db()
{
char s[100];
long sz,msz;
if(!(f=fopen(FileName,"r"))){fprintf(stdout,"File %s not found\n",FileName);return(-1);};
sz=0;msz=MAX_REC_IN_FILE;
while(strcmp(s,"BEGIN"))
{
if(sz++>msz){fprintf(stdout,"file %s very big\n",FileName);return(-1);};
fscanf(f,"%s",s);
}
while(1)
{
if(sz++>msz){fprintf(stdout,"file %s very big\n",FileName);return(-1);};
fscanf(f,"%s",s);if(!strcmp(s,"END"))break;curr.num=atoi(s);
fscanf(f,"%s %s",curr.dns,s);curr.addr=inet_addr(s);
for(i=0;i<MAX_IF;++i){fscanf(f,"%s",s);curr.if_addr[i]=inet_addr(s);}
add_rec();
}
fclose(f);
return(0);
}

int find_rec(long addr)
{
if(top){
tmp=top;
while(tmp)
{if(tmp->addr==addr)return(1);tmp=tmp->next;}}
return(0);
}

int add_hosts(long addr_prev,long addr,char *dns)
{
 int c;
 if(find_rec(addr_prev))
  {
   for(c=0;c<MAX_IF;++c)
    {
     if(tmp->if_addr[c]==addr)return(0);
     if(tmp->if_addr[c]==0){tmp->if_addr[c]=addr;return(0);}
    }
     fprintf(stdout,"if %d on router %d no addition; max if %d\n",addr,tmp->addr,MAX_IF);
  }
 else
  {
   curr.addr=addr_prev;curr.if_addr[0]=addr;strcpy(curr.dns,dns);add_rec();
  }
}

long rand_ip()
{
 int i1,i2,i3,i4;
 char ip[15];
  i1 = 1+(int) (253.0*rand()/(RAND_MAX+1.0));
  i2 = 1+(int) (253.0*rand()/(RAND_MAX+1.0));
  i3 = 1+(int) (253.0*rand()/(RAND_MAX+1.0));
  i4 = 1+(int) (223.0*rand()/(RAND_MAX+1.0));
  memset(ip,sizeof(ip),0);
  sprintf(ip,"%u.%u.%u.%u", i4, i3, i2, i1 );
  return(inet_addr(ip));
}

#ifdef TEST_UTILS
int main(void)
{
long d;
fprintf(stdout,ver_fu);
fprintf(stdout,"Test:\n");
for(d=0;d<5;++d)add_hosts(rand_ip(),rand_ip(),"domain");
print_rec();
fprintf(stdout,"save_db()\n");
save_db();
fprintf(stdout,"del_db()\n");del_db();
print_rec();
fprintf(stdout,"load_db()\n");load_db();
print_rec();
fprintf(stdout,"remove file %s\n",FileName);remove(FileName);
fprintf(stdout,"long 127.0.0.1:%x\n",iptol("127.0.0.1"));
fprintf(stdout,"ip 0x100007f:%s\n",ltoip(0x100007f));
return(0);
}
#endif